"""
Code illustration: 2.10

Adding Shortcut Icons toolbar
Displaying Line Numbers
Highlighting Current Line


@Tkinter GUI Application Development Blueprints
"""

import os, sys
from tkinter import Tk, PhotoImage, Menu, Frame, Text, Scrollbar, IntVar, \
    StringVar, BooleanVar, Button, Label, Listbox, Canvas, END
import tkinter.font as tkFont
import tkinter.filedialog
import tkinter.messagebox
import serial.tools.list_ports
import pyqrcode
import qrcode
from docx import Document
from docx.shared import Mm, Pt
from docx.enum.text import WD_ALIGN_PARAGRAPH
import PIL
from PIL import Image,ImageTk, ImageFont, ImageDraw
global qr_display, lbl_QR_Code, font
global 	input_file_name
input_file_name = 'numbers.txt'

def init_ports():
	ports = list(serial.tools.list_ports.comports())
	i = 0
	port_name = ''
	for pt in ports:
		#       Serial_Pts.set(str(ports[pt].name))
		port_name = port_name + ' ' + str(ports[i].name + '-' + ports[i].description.replace(' ', '-'))
		i = i + 1
	port_lists.set(port_name)

PROGRAM_NAME = "RFID Code printer"
file_name = None

root = Tk()
root.geometry('640x480')
root.title(PROGRAM_NAME)

global lbl_code_value
lbl_code_value = StringVar()
lbl_code_value.set('Card ID code')
global lb_ports_list
lb_ports_list = StringVar()
global cur_port, ports, cur_index
global act_port, serial
#cur_port = StringVar()
#cur_port = 'COM1'
act_port = 0
cur_index = 99
global rfidnum, cardnum
rfidnum = ["10","11","12","13","14","15","16","17","18"]
global pdf


def init_ports():
	ports = list(serial.tools.list_ports.comports())
	i = 0
	port_name = ''
	for pt in ports:
		#       Serial_Pts.set(str(ports[pt].name))
		port_name = port_name + ' ' + str(ports[i].name + '-' + ports[i].description.replace(' ', '-'))
		i = i + 1
	port_lists.set(port_name)

def update_line_numbers(event=None):
    line_numbers = get_line_numbers()
    line_number_bar.config(state='normal')
    line_number_bar.delete('1.0', 'end')
    line_number_bar.insert('1.0', line_numbers)
    line_number_bar.config(state='disabled')


def highlight_line(interval=100):
    content_text.tag_remove("active_line", 1.0, "end")
    content_text.tag_add(
        "active_line", "insert linestart", "insert lineend+1c")
    content_text.after(interval, toggle_highlight)


def undo_highlight():
    content_text.tag_remove("active_line", 1.0, "end")


def toggle_highlight(event=None):
    if to_highlight_line.get():
        highlight_line()
    else:
        undo_highlight()


def on_content_changed(event=None):
    update_line_numbers()


def get_line_numbers():
    output = ''
    if show_line_number.get():
        row, col = content_text.index("end").split('.')
        for i in range(1, int(row)):
            output += str(i) + '\n'
    return output


def display_about_messagebox(event=None):
    tkinter.messagebox.showinfo(
        "About", PROGRAM_NAME + "\nTkinter GUI Application\n Development Blueprints")


def display_help_messagebox(event=None):
    tkinter.messagebox.showinfo(
        "Help", "Help Book: \nTkinter GUI Application\n Development Blueprints",
        icon='question')


def exit_editor(event=None):
    if tkinter.messagebox.askokcancel("Quit?", "Really quit?"):
        root.destroy()


def new_file(event=None):
    root.title("Untitled")
    global file_name
    file_name = None
#    content_text.delete(1.0, END)
#    on_content_changed()

def  rndegg():
	root.filename =  filedialog.asksaveasfilename(initialdir = "/",title = "Select file",filetypes = (("jpeg files","*.jpg"),("all files","*.*")))
	print (root.filename)

def open_file(event=None):
    input_file_name = tkinter.filedialog.askopenfilename(defaultextension=".txt",
                                                         filetypes=[("All Files", "*.*"), ("Text Documents", "*.txt")])
    if input_file_name:
        global file_name
        file_name = input_file_name
        root.title('{} - {}'.format(os.path.basename(file_name), PROGRAM_NAME))
        content_text.delete(1.0, END)
        with open(file_name) as _file:
            content_text.insert(1.0, _file.read())
    on_content_changed()


def write_to_file(file_name):
    try:
        content = content_text.get(1.0, 'end')
        with open(file_name, 'w') as the_file:
            the_file.write(content)
    except IOError:
        tkinter.messagebox.showwarning("Save", "Could not save the file.")


def save_as(event=None):
    input_file_name = tkinter.filedialog.asksaveasfilename(defaultextension=".txt",
                                                           filetypes=[("All Files", "*.*"), ("Text Documents", "*.txt")])
    if input_file_name:
        global file_name
        file_name = input_file_name
        write_to_file(file_name)
        root.title('{} - {}'.format(os.path.basename(file_name), PROGRAM_NAME))
    return "break"

def save(event=None):
    global file_name
    if not file_name:
        save_as()
    else:
        write_to_file(file_name)
    return "break"


def select_all(event=None):
    content_text.tag_add('sel', '1.0', 'end')
    return "break"


def find_text(event=None):
    search_toplevel = Toplevel(root)
    search_toplevel.title('Find Text')



def search_output(needle, if_ignore_case, content_text,
                  search_toplevel, search_box):
    content_text.tag_remove('match', '1.0', END)



def cut():
    content_text.event_generate("<<Cut>>")
    on_content_changed()
    return "break"


def copy():
    content_text.event_generate("<<Copy>>")
    return "break"


def paste():
    content_text.event_generate("<<Paste>>")
    on_content_changed()
    return "break"


def undo():
    content_text.event_generate("<<Undo>>")
    on_content_changed()
    return "break"


def redo(event=None):
    content_text.event_generate("<<Redo>>")
    on_content_changed()
    return 'break'
    
##################################################################
#
#
#		ID Card code section
#
#####################################################################
font = ImageFont.truetype("times-ro.ttf", 13)
font2 = ImageFont.truetype("times-ro.ttf", 6)
font3 = ImageFont.truetype("t-new-rom-b.ttf", 12)

global doc
doc = Document('IDCard_P.docx')
font_pobox = doc.styles['Normal'].font
font_pobox.name = 'Times Roman'
font_pobox.bold = True
font_pobox.size = Pt(7)


    
def cmd_scan_ports():
    print('Scan_ports')
    ports=list(serial.tools.list_ports.comports())
    i = 0
    port_name = ''
    for pt in ports:
        port_name = port_name + ' ' + str(ports[i].name + '-' + ports[i].description.replace(' ', '-'))
        i = i + 1
    lb_ports_list.set(port_name)
    sys.stdout.flush()

def cmd_CurSelect(event):
    global cur_port, cur_index
    widget = event.widget
    selection=widget.curselection()
    picked = widget.get(selection[0])
    print(picked)
    index = int(widget.curselection()[0])
    value = widget.get(index)
    cur_index = int(widget.curselection()[0])
    selected_port =  value.split('-',1)
    cur_port = selected_port[0]
    print ('You selected item %d: "%s"' % (index, value))



def cmd_open_port():
    global cur_port, cur_index, act_port
    isError = 0

    if cur_index > 89 :
       tkinter.messagebox.showwarning("Open Port", "Plz select a port from the list ")
       return
    if act_port != 0:
       tkinter.messagebox.showwarning("Open Port", "Port already open")
       return
	
    try:
#       global cur_port, cur_index, act_port
       print('Port name' , cur_port, ' Index number ', cur_index)
       act_port = serial.Serial(ports[cur_index].name,9600, timeout = 3)  # open serial port
       sys.stdout.flush()
     
    except act_port.SerialException:
	#    except IOError:
       tkinter.messagebox.showwarning("Open Port", "Error opening Serial port .", cur_port)
       isError = 1
       
    if isError == 0 :
       print("Port labelcolour change") # set label green
#       lbl_ports.configure(background="#dfff80")
       Open_port.configure(background="#dfff80")
       Open_port.configure(text=cur_port)
       
	# else:
	# set label red  
	
def cmd_close_port():
    global cur_port, cur_index, act_port
    isError = 0
    
    try:
#       global cur_port, cur_index, act_port
       print('Port name' , cur_port, ' Index number ', cur_index)
       act_port.close()  # close serial port
#       lbl_ports.configure(background="#d9d9d9")
       Open_port.configure(background="#d9d9d9")
       Open_port.configure(text='''Open''')
       cur_index = 99
       act_port = 0
       sys.stdout.flush()
     
    except act_port.SerialException:
	#    except IOError:
       tkinter.messagebox.showwarning("Close Port", "Error closing Serial port .", cur_port)
       isError = 1

def cmd_get_cardnum():
    global act_port, lbl_code_value, rfidnum, qr_display,doc, cardnum, input_file_name
    cardcode = StringVar()
    Scan_Card.configure(activebackground="#dfff80")
    doc = Document('IDCard_P.docx')
    font_pobox = doc.styles['Normal'].font
    font_pobox.name = 'Times Roman'
    font_pobox.bold = True
    font_pobox.size = Pt(7)

    try:
       isError = 0
       print('Get Card Number')
       sys.stdout.flush() 

# check good read  check RFID code checksum
####
       msg = act_port.read_until('\x03',13)
       print(msg)
       if len(msg) > 1:
	       readchksm = int(msg[11])
	       byteA = chr(msg[1]) + chr(msg[2])
	       chksm = int(byteA, base=16)

	       byteA = chr(msg[3]) + chr(msg[4])
	       chksm = chksm ^ int(byteA, base=16)

	       byteA = chr(msg[5]) + chr(msg[6])
	       chksm = chksm ^ int(byteA, base=16)

	       byteA = chr(msg[7]) + chr(msg[8])
	       chksm = chksm ^ int(byteA, base=16)

	       byteA = chr(msg[9]) + chr(msg[10])
	       chksm = chksm ^ int(byteA, base=16)
       
	       print("Checksum tested")
	       if chksm == readchksm:
		       print("Chksums match")
		       for x in range(1, 10):
			       rfidnum[x - 1] = msg[x + 1]
			       pad = 0x30
			  # rfidnum[0] = msg[3]
		       rfidnum[0] = pad
	       idnum = ''.join(chr(x) for x in rfidnum)
	       cardnum = str(int(idnum,base=16))
	       lbl_CodeVal.configure(text= str(int(idnum,base=16)))
#
	       print("Record number to file")
	       numbers_file = open(input_file_name, 'a+')
	       numbers_file.write(cardnum + '\n')
	       numbers_file.close()
	       # create qr code and display

    except IOError:
       tkinter.messagebox.showwarning("Get Card number", "Error reading RFID ")
       isError = 1

    if isError == 0 :
       # set scan label green
       print('card scan colour green')
    # else:
       # set scan label red



def cmd_scan_card():
    global act_port, lbl_code_value, rfidnum, qr_display,doc, cardnum
    cardcode = StringVar()
    Scan_Card.configure(activebackground="#dfff80")
    doc = Document('IDCard_P.docx')
    font_pobox = doc.styles['Normal'].font
    font_pobox.name = 'Times Roman'
    font_pobox.bold = True
    font_pobox.size = Pt(7)

    try:
       isError = 0
       print('Scan Card')
       sys.stdout.flush() 
       # check good read
       # check RFID code checksum

       msg = act_port.read_until('\x03',13)
       print(msg)
       if len(msg) > 1:
	       readchksm = int(msg[11])
	       byteA = chr(msg[1]) + chr(msg[2])
	       chksm = int(byteA, base=16)

	       byteA = chr(msg[3]) + chr(msg[4])
	       chksm = chksm ^ int(byteA, base=16)

	       byteA = chr(msg[5]) + chr(msg[6])
	       chksm = chksm ^ int(byteA, base=16)

	       byteA = chr(msg[7]) + chr(msg[8])
	       chksm = chksm ^ int(byteA, base=16)

	       byteA = chr(msg[9]) + chr(msg[10])
	       chksm = chksm ^ int(byteA, base=16)
       
	       print("Checksum tested")
	       if chksm == readchksm:
		       print("Chksums match")
		       for x in range(1, 10):
			       rfidnum[x - 1] = msg[x + 1]
			       pad = 0x30
			  # rfidnum[0] = msg[3]
		       rfidnum[0] = pad
	       idnum = ''.join(chr(x) for x in rfidnum)
	       cardnum = idnum
	       lbl_CodeVal.configure(text= str(int(idnum,base=16)))
	       
	       # create qr code and display
	       


##################### pyqrcode section
	       qr_filename = 'cardpngs/' + str(int(idnum,base=16)) + '.png'
	       url = pyqrcode.create(idnum, error='H', version = 1)
	       url.png(qr_filename, scale = 7)
	       file_qrcode  = PhotoImage(file=qr_filename)
	       lbl_QR_Code.config(image=file_qrcode)
	       lbl_QR_Code.image=file_qrcode
	       print('Card image created', qr_filename)
	       Scan_Card.configure(activebackground="#ffff80")


##### doc creation section - may be controlled via a checkbox	       

	       p = doc.add_paragraph()
	       r = p.add_run()
	       paragraph_format = p.paragraph_format
	       paragraph_format.alignment = WD_ALIGN_PARAGRAPH.LEFT
	       r.add_text('If found please send to: PO Box 785, Hamilton Central QLD 4007 ')
	       p = doc.add_paragraph()
	       sentence = p.add_run()
	       sentence.font.name = 'Arial'
	       sentence.font.size = Pt(16)
	       sentence.add_text(str(int(idnum,base=16)))
	       paragraph_format = p.paragraph_format
	       paragraph_format.alignment = WD_ALIGN_PARAGRAPH.CENTER
	       r = p.add_run() 
	       p = doc.add_paragraph()
#	       r = p.add_run()
	       r.add_picture(qr_filename,width=Mm(45.0))
	       doc.save('carddocxs/' + str(int(idnum,base=16)) + '.docx')
	       paragraph_format = p.paragraph_format
	       paragraph_format.alignment = WD_ALIGN_PARAGRAPH.LEFT


    except IOError:
       tkinter.messagebox.showwarning("Scan Card", "Error reading RFID ")
       isError = 1

    if isError == 0 :
       # set scan label green
       print('card scan colour green')
    # else:
       # set scan label red
    

def cmd_record_nums():
    print('Record numbers to file')
    numbers_file = open('input_file_name', 'a+')
    
    # open(input_file_name, append, w)
    # file path 'carddocxs/'
#	numbers_file.write('')
#	numbers_file.close()

    sys.stdout.flush()

def cmd_display_card():
    print('Display card')
    sys.stdout.flush()
    
def cmd_num_file():
#	root.filename =  filedialog.asksaveasfilename(initialdir = "carddocxs/",title = "Select file",filetypes = (("jpeg files","*.jpg"),("all files","*.*")))
#	print (root.filename)
	print('number file')
	global input_file_name
	files = [('All files','*.*'), ('Text Doc','*.txt')]
	input_file_name = tkinter.filedialog.asksaveasfilename(initialdir = "carddocxs/", defaultextension=files, filetypes = files)
	print (input_file_name)
	sys.stdout.flush()
	
def	cmd_test_code():
	print('Test Code')
	sys.stdout.flush()
	


#########################################################
#
#			Inline code
#
##########################################################

qr_code_image = PhotoImage(file='qr1.png')

#qr_code_image = PhotoImage(file='cardpngs/4570325.png')
#img = Image.open("qrcodes/4570325-10.png")


new_file_icon = PhotoImage(file='icons/new_file.gif')
open_file_icon = PhotoImage(file='icons/open_file.gif')
save_file_icon = PhotoImage(file='icons/save.gif')
cut_icon = PhotoImage(file='icons/cut.gif')
copy_icon = PhotoImage(file='icons/copy.gif')
paste_icon = PhotoImage(file='icons/paste.gif')
undo_icon = PhotoImage(file='icons/undo.gif')
redo_icon = PhotoImage(file='icons/redo.gif')

menu_bar = Menu(root)
file_menu = Menu(menu_bar, tearoff=0)
file_menu.add_command(label='New', accelerator='Ctrl+N', compound='left',
                      image=new_file_icon, underline=0, command=new_file)
file_menu.add_command(label='Open', accelerator='Ctrl+O', compound='left',
                      image=open_file_icon, underline=0, command=open_file)
file_menu.add_command(label='Save', accelerator='Ctrl+S',
                      compound='left', image=save_file_icon, underline=0, command=save)
file_menu.add_command(
    label='Save as', accelerator='Shift+Ctrl+S', command=save_as)
file_menu.add_separator()
file_menu.add_command(label='Exit', accelerator='Alt+F4', command=exit_editor)
menu_bar.add_cascade(label='File', menu=file_menu)

edit_menu = Menu(menu_bar, tearoff=0)
edit_menu.add_command(label='Undo', accelerator='Ctrl+Z',
                      compound='left', image=undo_icon, command=undo)
edit_menu.add_command(label='Redo', accelerator='Ctrl+Y',
                      compound='left', image=redo_icon, command=redo)
edit_menu.add_separator()
edit_menu.add_command(label='Cut', accelerator='Ctrl+X',
                      compound='left', image=cut_icon, command=cut)
edit_menu.add_command(label='Copy', accelerator='Ctrl+C',
                      compound='left', image=copy_icon, command=copy)
edit_menu.add_command(label='Paste', accelerator='Ctrl+V',
                      compound='left', image=paste_icon, command=paste)
edit_menu.add_separator()
edit_menu.add_command(label='Find', underline=0,
                      accelerator='Ctrl+F', command=find_text)
edit_menu.add_separator()
edit_menu.add_command(label='Select All', underline=7,
                      accelerator='Ctrl+A', command=select_all)
menu_bar.add_cascade(label='Edit', menu=edit_menu)


view_menu = Menu(menu_bar, tearoff=0)
show_line_number = IntVar()
show_line_number.set(1)
view_menu.add_checkbutton(label='Show Line Number', variable=show_line_number,
                          command=update_line_numbers)
show_cursor_info = IntVar()
show_cursor_info.set(1)
view_menu.add_checkbutton(
    label='Show Cursor Location at Bottom', variable=show_cursor_info)
to_highlight_line = BooleanVar()
view_menu.add_checkbutton(label='Highlight Current Line', onvalue=1,
                          offvalue=0, variable=to_highlight_line, command=toggle_highlight)
themes_menu = Menu(menu_bar, tearoff=0)
view_menu.add_cascade(label='Themes', menu=themes_menu)

color_schemes = {
    'Default': '#000000.#FFFFFF',
    'Greygarious': '#83406A.#D1D4D1',
    'Aquamarine': '#5B8340.#D1E7E0',
    'Bold Beige': '#4B4620.#FFF0E1',
    'Cobalt Blue': '#ffffBB.#3333aa',
    'Olive Green': '#D1E7E0.#5B8340',
    'Night Mode': '#FFFFFF.#000000',
}

theme_choice = StringVar()
theme_choice.set('Default')
for k in sorted(color_schemes):
    themes_menu.add_radiobutton(label=k, variable=theme_choice)
menu_bar.add_cascade(label='View', menu=view_menu)

about_menu = Menu(menu_bar, tearoff=0)
about_menu.add_command(label='About', command=display_about_messagebox)
about_menu.add_command(label='Help', command=display_help_messagebox)
menu_bar.add_cascade(label='About',  menu=about_menu)
root.config(menu=menu_bar)

shortcut_bar = Frame(root,  height=25)
shortcut_bar.pack(expand='no', fill='x')

fontStyle = tkFont.Font(family="Lucida Grande", size=12)



lb_ports = Listbox(root)
lb_ports.place(relx=0.293, rely=0.111, relheight=0.200
                , relwidth=0.69)
lb_ports.configure(background="white")
lb_ports.configure(disabledforeground="#a3a3a3")
lb_ports.configure(font="TkFixedFont")
lb_ports.configure(foreground="#000000")
lb_ports.configure(listvariable=lb_ports_list)
#lb_ports.configure()
lb_ports.bind("<<ListboxSelect>>", cmd_CurSelect)


Scan_Port = Button(root)
Scan_Port.place(relx=0.01, rely=0.150, height=34, width=50)
Scan_Port.configure(activebackground="#ececec")
Scan_Port.configure(activeforeground="#000000")
Scan_Port.configure(background="#d9d9d9")
Scan_Port.configure(command=cmd_scan_ports)
Scan_Port.configure(disabledforeground="#a3a3a3")
Scan_Port.configure(foreground="#000000")
Scan_Port.configure(highlightbackground="#d9d9d9")
Scan_Port.configure(highlightcolor="black")
Scan_Port.configure(pady="0")
Scan_Port.configure(text='''Scan''')


Open_port = Button(root)
Open_port.place(relx=0.110, rely=0.150, height=34, width=50)
Open_port.configure(activebackground="#ececec")
Open_port.configure(activeforeground="#000000")
Open_port.configure(background="#d9d9d9")
Open_port.configure(command=cmd_open_port)
Open_port.configure(disabledforeground="#a3a3a3")
Open_port.configure(foreground="#000000")
Open_port.configure(highlightbackground="#d9d9d9")
Open_port.configure(highlightcolor="black")
Open_port.configure(pady="0")
Open_port.configure(text='''Open''')

Close_port = Button(root)
Close_port.place(relx=0.200, rely=0.150, height=34, width=50)
Close_port.configure(activebackground="#ececec")
Close_port.configure(activeforeground="#000000")
Close_port.configure(background="#d9d9d9")
Close_port.configure(command=cmd_close_port)
Close_port.configure(disabledforeground="#a3a3a3")
Close_port.configure(foreground="#000000")
Close_port.configure(highlightbackground="#d9d9d9")
Close_port.configure(highlightcolor="black")
Close_port.configure(pady="0")
Close_port.configure(text='''Close''')



lbl_port = Label(root)
lbl_port.place(relx=0.127, rely=0.015, height=30, width=250)
lbl_port.configure(background="#ffff80")
lbl_port.configure(disabledforeground="#a3a3a3")
lbl_port.configure(foreground="#000000")
lbl_port.configure(relief="groove")
lbl_port.configure(text='''Serial Port setup''')


lbl_port = Label(root)
lbl_port.place(relx=0.127, rely=0.380, height=30, width=250)
lbl_port.configure(background="#ffff80")
lbl_port.configure(disabledforeground="#a3a3a3")
lbl_port.configure(foreground="#000000")
lbl_port.configure(relief="groove")
lbl_port.configure(text='''Card Processing''')


lbl_CardCode = Label(root)
lbl_CardCode.place(relx=0.630, rely=0.380, height=30, width=120)
lbl_CardCode.configure(activebackground="#f9f9f9")
lbl_CardCode.configure(activeforeground="black")
lbl_CardCode.configure(background="#ffff80")
lbl_CardCode.configure(disabledforeground="#a3a3a3")
lbl_CardCode.configure(foreground="#000000")
lbl_CardCode.configure(highlightbackground="#d9d9d9")
lbl_CardCode.configure(highlightcolor="black")
lbl_CardCode.configure(relief="ridge")
lbl_CardCode.configure(text='''Card code''')


fontStyle = tkFont.Font(family="Lucida Grande", size=20)

lbl_CodeVal = Label(root)
lbl_CodeVal.place(relx=0.630, rely=0.480, height=30, width=200)
lbl_CodeVal.configure(activebackground="#ffffff")
lbl_CodeVal.configure(background="#ffffff")
lbl_CodeVal.configure(disabledforeground="#a3a3a3")
lbl_CodeVal.configure(foreground="#000000")
lbl_CodeVal.configure(justify='right')
lbl_CodeVal.configure(relief="sunken")
lbl_CodeVal.configure(text='''Card ID Code''', font=fontStyle)
#lbl_CodeVal.configure(textvariable=lbl_code_value)


Scan_Card = Button(root)
Scan_Card.place(relx=0.01, rely=0.500, height=60, width=80)
#Scan_Card.configure(activebackground="#ececec")
Scan_Card.configure(activebackground="#ffff80")
Scan_Card.configure(activeforeground="#000000")
Scan_Card.configure(background="#d9d9d9")
Scan_Card.configure(command=cmd_get_cardnum)
Scan_Card.configure(disabledforeground="#a3a3a3")
Scan_Card.configure(foreground="#000000")
Scan_Card.configure(highlightbackground="#d9d9d9")
Scan_Card.configure(highlightcolor="black")
Scan_Card.configure(pady="0")
Scan_Card.configure(text='''Record #s''')

Scan_Cards = Button(root)
Scan_Cards.place(relx=0.160, rely=0.500, height=60, width=80)
Scan_Cards.configure(activebackground="#ececec")
Scan_Cards.configure(activeforeground="#000000")
Scan_Cards.configure(background="#d9d9d9")
Scan_Cards.configure(command=cmd_scan_card)
Scan_Cards.configure(disabledforeground="#a3a3a3")
Scan_Cards.configure(foreground="#000000")
Scan_Cards.configure(highlightbackground="#d9d9d9")
Scan_Cards.configure(highlightcolor="black")
Scan_Cards.configure(pady="0")
Scan_Cards.configure(text='''Print card''')


Display_Card = Button(root)
Display_Card.place(relx=0.320, rely=0.500, height=60, width=80)
Display_Card.configure(activebackground="#ececec")
Display_Card.configure(activeforeground="#000000")
Display_Card.configure(background="#d9d9d9")
Display_Card.configure(command=cmd_display_card)
Display_Card.configure(disabledforeground="#a3a3a3")
Display_Card.configure(foreground="#000000")
Display_Card.configure(highlightbackground="#d9d9d9")
Display_Card.configure(highlightcolor="black")
Display_Card.configure(pady="0")
Display_Card.configure(text='''Display card''')


Test_Code = Button(root)
Test_Code.place(relx=0.160, rely=0.650, height=40, width=80)
Test_Code.configure(activebackground="#ececec")
Test_Code.configure(activeforeground="#000000")
Test_Code.configure(background="#d9d9d9")
Test_Code.configure(command=cmd_test_code)
Test_Code.configure(disabledforeground="#a3a3a3")
Test_Code.configure(foreground="#000000")
Test_Code.configure(highlightbackground="#d9d9d9")
Test_Code.configure(highlightcolor="black")
Test_Code.configure(pady="0")
Test_Code.configure(text='''Test Code''')

Card_Nums = Button(root)
Card_Nums.place(relx=0.010, rely=0.650, height=40, width=80)
Card_Nums.configure(activebackground="#ececec")
Card_Nums.configure(activeforeground="#000000")
Card_Nums.configure(background="#d9d9d9")
Card_Nums.configure(command=cmd_num_file)
Card_Nums.configure(disabledforeground="#a3a3a3")
Card_Nums.configure(foreground="#000000")
Card_Nums.configure(highlightbackground="#d9d9d9")
Card_Nums.configure(highlightcolor="black")
Card_Nums.configure(pady="0")
Card_Nums.configure(text='''Numbers File''')


#lbl_ports = Label(root)
#lbl_ports.place(relx=0.417, rely=0.390, height=50, width=70)
#lbl_ports.configure(background="#d9d9d9")
#lbl_ports.configure(disabledforeground="#a3a3a3")
#lbl_ports.configure(foreground="#000000")
#lbl_ports.configure(relief="groove")
#lbl_ports.configure(text='''Port''')

lbl_read = Label(root)
lbl_read.place(relx=0.027, rely=0.820, height=50, width=70)
lbl_read.configure(background="#d9d9d9")
lbl_read.configure(disabledforeground="#a3a3a3")
lbl_read.configure(foreground="#000000")
lbl_read.configure(relief="groove")
lbl_read.configure(text='''Read''')

lbl_ChkSum = Label(root)
lbl_ChkSum.place(relx=0.150, rely=0.820, height=50, width=70)
lbl_ChkSum.configure(background="#d9d9d9")
lbl_ChkSum.configure(disabledforeground="#a3a3a3")
lbl_ChkSum.configure(foreground="#000000")
lbl_ChkSum.configure(relief="groove")
lbl_ChkSum.configure(text='''CHK Sum''')

lbl_QR = Label(root)
lbl_QR.place(relx=0.633, rely=0.560, height=30, width=120)
lbl_QR.configure(background="#ffff80")
lbl_QR.configure(disabledforeground="#a3a3a3")
lbl_QR.configure(foreground="#000000")
lbl_QR.configure(relief="ridge")
lbl_QR.configure(text='''QR Code''')




lbl_QR_Code = Label(root)
lbl_QR_Code.place(relx=0.633, rely=0.643, relheight=0.333
                , relwidth=0.300)
lbl_QR_Code.configure(relief='sunken')
lbl_QR_Code.configure(borderwidth="2")
lbl_QR_Code.configure(relief="sunken")
lbl_QR_Code.configure(background="#ffffff")
lbl_QR_Code.configure(highlightbackground="#d9d9d9")
lbl_QR_Code.configure(highlightcolor="black")
# new_file_icon
lbl_QR_Code.configure(text='''More QR Code''')
#qr_code_image
lbl_QR_Code.configure(image=qr_code_image)




# adding shortcut icons
icons = ('new_file', 'open_file', 'save')
for i, icon in enumerate(icons):
    tool_bar_icon = PhotoImage(file='icons/{}.gif'.format(icon))
    cmd = eval(icon)
    tool_bar = Button(shortcut_bar, image=tool_bar_icon, command=cmd)
    tool_bar.image = tool_bar_icon
    tool_bar.pack(side='left')


#line_number_bar = Text(root, width=4, padx=3, takefocus=0,  border=0,
#                       background='khaki', state='disabled',  wrap='none')
#line_number_bar.pack(side='left',  fill='y')

ports = list(serial.tools.list_ports.comports())
i = 0
port_name = ''
for pt in ports:
	#       Serial_Pts.set(str(ports[pt].name))
	port_name = port_name + ' ' + str(ports[i].name + '-' + ports[i].description.replace(' ', '-'))
	i = i + 1
lb_ports_list.set(port_name)



root.protocol('WM_DELETE_WINDOW', exit_editor)
root.mainloop()

